//
//  .2005
//

#define _CRT_SECURE_NO_DEPRECATE 1

/* These include files are needed for the following template code.            */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <Windows.h>

#include <uf_cam.h>
#include <uf_part.h>
#include <uf_cfi.h>
#include <uf_mom.h>

#include <uf.h>
#include <uf_defs.h>
#include <uf_exit.h>
#include <uf_ui.h>
#include <uf_styler.h>
#include <uf_mb.h>

#include "pp_create_own_list.h"


/* The following definition defines the number of callback entries */
/* in the callback structure:                                      */
/* UF_STYLER_callback_info_t PP_cbs */
#define PP_CB_COUNT ( 9 + 1 ) /* Add 1 for the terminator */

/*--------------------------------------------------------------------------
The following structure defines the callback entries used by the
styler file.  This structure MUST be passed into the user function,
UF_STYLER_create_dialog along with PP_CB_COUNT.
--------------------------------------------------------------------------*/
static UF_STYLER_callback_info_t PP_cbs[PP_CB_COUNT] =
{
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_CONSTRUCTOR_CB  , 0, PP_constructor_cb},
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_OK_CB           , 0, PP_ok_cb},
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_APPLY_CB        , 0, PP_apply_cb},
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_CANCEL_CB       , 0, PP_cancel_cb},
 {PP_LIST_LIST          , UF_STYLER_ACTIVATE_CB     , 0, PP_list_list_cb},
 {PP_LIST_LIST          , UF_STYLER_DOUBLE_CLICK_CB , 0, PP_list_list_dbl_cb},
 {PP_BLO_BUT            , UF_STYLER_ACTIVATE_CB     , 0, PP_blo_but_act_cb},
 {PP_LIST_CURR          , UF_STYLER_ACTIVATE_CB     , 0, PP_list_curr_cb},
 {PP_LIST_CURR          , UF_STYLER_DOUBLE_CLICK_CB , 0, PP_list_curr_dbl_cb},
 {UF_STYLER_NULL_OBJECT, UF_STYLER_NO_CB, 0, 0 }
};



/*--------------------------------------------------------------------------
UF_MB_styler_actions_t contains 4 fields.  These are defined as follows:

Field 1 : the name of your dialog that you wish to display.
Field 2 : any client data you wish to pass to your callbacks.
Field 3 : your callback structure.
Field 4 : flag to inform menubar of your dialog location.  This flag MUST
          match the resource set in your dialog!  Do NOT ASSUME that changing
          this field will update the location of your dialog.  Please use the
          UIStyler to indicate the position of your dialog.
--------------------------------------------------------------------------*/
static UF_MB_styler_actions_t actions[] = {
    { "pp_create_own_list.dlg",  NULL,   PP_cbs,  UF_MB_STYLER_IS_NOT_TOP },
    { NULL,  NULL,  NULL,  0 } /* This is a NULL terminated list */
};




#define UF_CALL(X) (report( __FILE__, __LINE__, #X, (X)))

static int report( char *file, int line, char *call, int irc)
{
  if (irc)
  {
     char    messg[133];
     printf("%s, line %d:  %s\n", file, line, call);
     (UF_get_fail_message(irc, messg)) ?
       printf("    returned a %d\n", irc) :
       printf("    returned error %d:  %s\n", irc, messg);
  }
  return(irc);
}


struct Ini
{
  int  active ;
  char VER[MAX_FSPEC_SIZE+1] ;
  char RUN_CAM_EXE[MAX_FSPEC_SIZE+1] ;
  char RUN_CAM_COPY[MAX_FSPEC_SIZE+1];
  char FILE_CAM_GENERAL[MAX_FSPEC_SIZE+1];
} sIni;
char  *inifile="pp_create_own_list.ini\0";

int post_count ; const char **post_names ;
int user_count ; const char **user_names ;

int user_count_choice ; char **user_names_choice ;


/*======================================================================*/
int find_filename( char *file , char * findfullfilename)
{
 char  str[MAX_LINE_SIZE+1]="";
 int   i, error ;
 char *path , envpath[MAX_FSPEC_SIZE+1] , runpath[MAX_FSPEC_SIZE+1] ;
 char env_names[][25]={
    "UGII_VENDOR_DIR",
    "UGII_USER_DIR" ,
    "UGII_SITE_DIR" ,
    "USER_UFUN" ,
    "UGII_INITIAL_UFUN_DIR" ,
    "UGII_TMP_DIR" ,
    "HOME" ,
    "TMP",
    NULL } ;

 path = (char *) malloc(MAX_FSPEC_SIZE+10);

 error=-1;
 for (i=0;i<8;i++) {
   runpath[0]='\0';  envpath[0]='\0';  path=envpath;
   UF_translate_variable(env_names[i], &path);
   if (path!=NULL) {
      strcpy(runpath,path); strcat(runpath,"\\application\\");  strcat(runpath,file);
      UF_CFI_ask_file_exist (runpath,&error);
      UF_print_syslog(runpath,FALSE); UF_print_syslog("\n",FALSE);
      if (error==0) {	break ; }
    } //if (envpath!=NULL)
   if (error==0) {	break ; }
 } // for

 sprintf(findfullfilename,"%s",runpath);

 return(error);
}


bool GetParam(char *Section,char *Param,char *Value,int Size, char *FileName)
{
  char *tmp="";
  int res=GetPrivateProfileString(Section,Param,tmp,Value,Size,FileName);
  if(!res) return false;
  return true;
}

int _ini_read(char * inifilename)
{
 int   error ;
 char  tmp[MAX_FSPEC_SIZE+1]="";
 char  inipath[MAX_FSPEC_SIZE+1] ;

 printf("\n ----start----- _ini_read ");

 sIni.active=0;
 sprintf(sIni.VER,"%s","1\0");
 sprintf(sIni.RUN_CAM_EXE,"%s","cmd\0");
 sprintf(sIni.RUN_CAM_COPY,"%s","pp_create_own_list_copy.bat\0");
 sprintf(sIni.FILE_CAM_GENERAL,"%s","pp_create_own_list_cam_general.dat\0");

 printf("\n _ini_read init finish");

 //    
 inipath[0]='\0';
 error=find_filename( inifilename ,inipath ) ;

 if (error==0) {
  /*  ini  */
  // HANDLE hFile=CreateFile(runpath,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
  // error=GetLastError();
  // if(hFile==INVALID_HANDLE_VALUE) {
  //  UF_print_syslog("Cant open and read *.ini file!\n",FALSE);
  //  return (-1);
  // }
  // CloseHandle(hFile);

   printf("\n _ini_read - read ini");

   sIni.active=1;
   if(GetParam("CAM_MAIN","VERSION",tmp,MAX_FSPEC_SIZE,inipath)) sprintf(sIni.VER,"%.255s",tmp);
   if(GetParam("CAM_MAIN","RUN_CAM_EXE",tmp,MAX_FSPEC_SIZE,inipath))   sprintf(sIni.RUN_CAM_EXE,"%.255s",tmp);
   if(GetParam("CAM_MAIN","RUN_CAM_COPY",tmp,MAX_FSPEC_SIZE,inipath))   sprintf(sIni.RUN_CAM_COPY,"%.255s",tmp);
   if(GetParam("CAM_MAIN","FILE_CAM_GENERAL",tmp,MAX_FSPEC_SIZE,inipath))  sprintf(sIni.FILE_CAM_GENERAL,"%.255s",tmp);

  } else {

   printf ("\n\t UF_CFI_ask_file_exist(%d) - %s ",error,inifilename);
   UF_print_syslog("Cant open and read *.ini file!\n",FALSE);

  }

 tmp[0]='\0';
 error=find_filename( sIni.RUN_CAM_EXE ,tmp ) ;
 if (error==0) sprintf(sIni.RUN_CAM_EXE,"%.255s",tmp);
 tmp[0]='\0';
 error=find_filename( sIni.RUN_CAM_COPY ,tmp ) ;
 if (error==0) sprintf(sIni.RUN_CAM_COPY,"%.255s",tmp);
 tmp[0]='\0';
 error=find_filename( sIni.FILE_CAM_GENERAL ,tmp ) ;
 if (error==0) sprintf(sIni.FILE_CAM_GENERAL,"%.255s",tmp);

 printf("\n%d\n",sIni.active);
 printf("%s\n",sIni.VER);
 printf("%s\n",sIni.RUN_CAM_EXE);
 printf("%s\n",sIni.RUN_CAM_COPY);
 printf("%s\n",sIni.FILE_CAM_GENERAL);

 printf("\n ----end----- _ini_read\n");

 return (0);
}

/*======================================================================*/
int _run_process( char *runpath )
{
 int   ret = 0 ;

 STARTUPINFO si;
 PROCESS_INFORMATION pi;

 ZeroMemory( &si, sizeof(si) );
 si.cb = sizeof(si);
 ZeroMemory( &pi, sizeof(pi) );

 // Start the child process.
 if( !CreateProcess( NULL, // No module name (use command line).
     runpath,       // Command line.
     NULL,             // Process handle not inheritable.
     NULL,             // Thread handle not inheritable.
     FALSE,            // Set handle inheritance to FALSE.
     0,                // No creation flags.
     NULL,             // Use parent's environment block.
     NULL,             // Use parent's starting directory.
     &si,              // Pointer to STARTUPINFO structure.
     &pi )             // Pointer to PROCESS_INFORMATION structure.
 )
 {
    printf ("\n\t (CreateProcess) - error run %s ",runpath);
    ret=-1;
 }

 return(ret);
}


int pp_create_list(char * post,char *user_post)
{
	char str[2*256+133]="",str_c[2*256+133]="" , *pstr ;
	int i ;
	FILE *fout , *fin ;
	char  *ptr, temp_file [MAX_FSPEC_SIZE+1];

  char *mes;
  UF_UI_message_buttons_t buttons1 = { TRUE, FALSE, FALSE, "Ok", NULL, NULL, 1, 0, 0 };
  int response = 0;

	printf("\n==Start pp_create_list()\n");
	printf("|post=%s\n|user_post=%s\n",post,user_post);

	printf("|user_count_choice=%d\n",user_count_choice);
  for (i=0;i<user_count_choice;i++) {
    printf("| %d) %s \n",i,user_names_choice[i]);
  }

 	if (NULL!=strstr(post,user_post)) {
     str[0]='\0';
     sprintf(str,"   -     !\n    ");
     mes=str;
     UF_UI_message_dialog("Error..!!!", UF_UI_MESSAGE_WARNING, &mes, 1, TRUE, &buttons1, &response);
     return (-3);
  }

//   
  UF_CALL(UF_translate_variable("UGII_TMP_DIR", &ptr));
  temp_file[0]='\0';
  sprintf(temp_file,"%s\\template_post%d.dat",ptr,rand());

  i=CopyFile( (LPCTSTR)post, (LPCTSTR)temp_file, FALSE );
  printf("\nCopyFile(%d)=%s\n",i,temp_file);
  UF_print_syslog (temp_file,FALSE);UF_print_syslog("\n",FALSE);

  fin = fopen(user_post,"r");
  if (fin==NULL) {
     str[0]='\0';
     sprintf(str,"   %s  \n    ",user_post);
     mes=str;
     UF_UI_message_dialog("Cannot open file..?", UF_UI_MESSAGE_WARNING, &mes, 1, TRUE, &buttons1, &response);
     return (-1);
  }

  fout = fopen(post,"w");
  if (fout==NULL) {
     fclose ( fin ) ;

     str[0]='\0';
     sprintf(str,"   %s  \n    ",post);
     mes=str;
     UF_UI_message_dialog("Cannot open file..?", UF_UI_MESSAGE_WARNING, &mes, 1, TRUE, &buttons1, &response);
     return (-2);
  }

// ----------------------------
fputs("###############################################################################\n",fout);
fputs("# template_post config file - Event Handler and Definition files for \n",fout);
fputs("#                             Generic Machine\n",fout);
fputs("#\n",fout);
fputs("#\n",fout);
fputs("#\n",fout);
fputs("###############################################################################\n",fout);
// ----------------------------
  for (i=0;i<user_count_choice;i++) {
    rewind(fin) ;
    //fseek(fin, 0 , SEEK_SET	);
    //printf("|=== %d) %s \n",i,user_names_choice[i]);
    while (!feof(fin)) {
    	fgets(str,2*256+133-1,fin);
    	strcpy(str_c,str);
    	pstr = strtok(str, ",");
    	if (0==strcmp(pstr,user_names_choice[i])) {
    		 fputs(str_c,fout);
    		 //fprintf(fout,"%s\n",str_c);
    	}

    }
  }
// ----------------------------
  fclose ( fin ) ;
  fclose ( fout ) ;
// ----------------------------
  printf("| create  file template posts - done\n");
	printf("\n==End pp_create_list()\n");
	return(0);
}

int pp_copy_file( char * parm )
{
	UF_MOM_id_t   mom ;
	char  command[2*256+1] ;
	int   err ;
	char  *ptr2;

	printf("\n==Start pp_copy_file()\n");

  if (NULL!=strstr(sIni.RUN_CAM_EXE,"TCL")) {

    command[0]='\0';
    sprintf(command,"\"%s\"",sIni.RUN_CAM_COPY);
    printf("| MOM command = %s\n",command);

    /* Get the MOM id from the ufusr param */
    err = UF_CALL( UF_MOM_ask_mom (parm, &mom) ) ;
    if ( 0 != err ) {
      UF_print_syslog("Don't get the MOM id from the ufusr param \n",FALSE);
      uc1601("Don't get the MOM id from the ufusr param \n Program don't copy postprocessors",1);
    }
    //History: Originally released in NX2
    if (0 == err) UF_CALL( UF_MOM_execute_command(mom,command) ) ;

  } else {

  	if (NULL!=strstr(sIni.RUN_CAM_EXE,"cmd")) {

      command[0]='\0'; sprintf(command,"cmd /Q /C \"%s\"",sIni.RUN_CAM_COPY);
      err=_run_process( command ) ;
      if (err<0) {
        UF_CALL(UF_translate_variable("WINDIR", &ptr2));
        command[0]='\0';
        sprintf(command,"\"%s\\system32\\cmd.exe\" /Q /C \"%s\"",ptr2,sIni.RUN_CAM_COPY);
        err=_run_process( command ) ;
        if (err<0) { uc1601(" Program don't copy postprocessors \n Do this - manual ...",1); }
      }

    } else {

    	  command[0]='\0'; sprintf(command,"\"%s\" \"%s\"",sIni.RUN_CAM_EXE,sIni.RUN_CAM_COPY);
        err=_run_process( command ) ;
        if (err<0) { uc1601(" Program don't copy postprocessors \n Do this - manual ...",1); }

    }

  }

  printf("| command = %s \n",command);
	printf("\n==End pp_copy_file()\n");
	return(0);
}


int do_load_dlg( char * parm)
{
 int  response   = 0;
 int  error_code = 0;

 const char *pcam_config_filename ;
 char cam_config_filename[MAX_FSPEC_SIZE+1] ;

 const char *ppost_template_filename ;
 char post_template_filename[MAX_FSPEC_SIZE+1] ;

 const char *puser_post_template_filename ;
 char user_post_template_filename[MAX_FSPEC_SIZE+1] ;

 char   user_cam_config_filename [MAX_FSPEC_SIZE+1]="";

 int module_id;
 UF_ask_application_module(&module_id);
 if (UF_APP_CAM!=module_id) {
    // UF_APP_GATEWAY UF_APP_CAM UF_APP_MODELING UF_APP_NONE
    uc1601(" DLL -    \n - 2005.",1);
    return (0);
 }

 /* Ask displayed part tag */
 if (NULL_TAG==UF_PART_ask_display_part()) {
   uc1601("Cam-  .....\n  .",1);
   return (0);
 }

 printf("\n\n Start pp_create() \n\n") ;

 _ini_read( inifile );

 UF_UI_toggle_stoplight(1);

 UF_CALL( UF_CAM_ask_config_file (&pcam_config_filename) );
 cam_config_filename[0]='\0'; sprintf(cam_config_filename, "%s\0", pcam_config_filename );
 printf( "cam_config_filename=%s\n", cam_config_filename );
 UF_print_syslog (cam_config_filename,FALSE);UF_print_syslog("\n",FALSE);

 UF_CALL( UF_CAM_ask_post_template_name ( &ppost_template_filename ) );
 post_template_filename[0]='\0';sprintf(post_template_filename, "%s\0", ppost_template_filename );
 printf( "post_template_filename=%s\n", post_template_filename );
 UF_print_syslog (post_template_filename,FALSE);UF_print_syslog("\n",FALSE);

 user_cam_config_filename[0]='\0';
 sprintf (user_cam_config_filename,"%s\0",sIni.FILE_CAM_GENERAL);
 UF_CFI_ask_file_exist (user_cam_config_filename,&error_code);
 if (error_code!=0) {
 	 user_cam_config_filename[0]='\0';
   sprintf (user_cam_config_filename,"%s\0",cam_config_filename);
 }
 printf("user_cam_config_filename=%s \n",user_cam_config_filename);

  //   
  UF_CALL( UF_CAM_opt_ask_post_names (&post_count,&post_names ) );
  //if (post_count<=0) { post_count=0 ; uc1601 ("   = 0", TRUE );  }

	//  
	UF_CALL( UF_CAM_reinit_session ( user_cam_config_filename ) );

 //     
 UF_CALL( UF_CAM_ask_post_template_name ( &puser_post_template_filename ) );
 user_post_template_filename[0]='\0';sprintf(user_post_template_filename, "%s\0", puser_post_template_filename );
 printf( "user_post_template_filename=%s\n", user_post_template_filename );
 UF_print_syslog (user_post_template_filename,FALSE);UF_print_syslog("\n",FALSE);

  //   
  UF_CALL( UF_CAM_opt_ask_post_names (&user_count,&user_names ) );
  if (user_count<=0) { user_count=0 ; uc1601 ("   = 0", TRUE );  }

 if ( ( error_code = UF_STYLER_create_dialog (actions->styler_file,
          PP_cbs,      /* Callbacks from dialog */
          PP_CB_COUNT, /* number of callbacks*/
          NULL,        /* This is your client data */
          &response ) ) != 0 )
 {
    uc1601 ("Cannot find Dialog (*.dlg) or memory overflow .....\n program breaking...", TRUE );
 } else {
    /* UF_UI_OK UF_UI_CANCEL UF_UI_BACK UF_UI_PICK_RESPONSE UF_UI_CB_TERMINATE */
    if (response==UF_UI_OK) {
 	     if (0<=pp_create_list(post_template_filename,user_post_template_filename))
 	         pp_copy_file( parm ) ;
 	  }
 }

//     
   UF_CALL( UF_CAM_reinit_session ( cam_config_filename ) );

 //UF_free(&pcam_config_filename) ;
 //UF_free(&ppost_template_filename) ;
 //UF_free(&puser_post_template_filename) ;

  UF_free_string_array( post_count, (char **)post_names );
  UF_free_string_array( user_count, (char **)user_names );

  //UF_free_string_array( user_count_choice, (char **)user_names_choice );

 UF_UI_toggle_stoplight(0);

 printf("\n\n End pp_create() \n\n") ;

  return(0);
}


int _choice_cb ( int dialog_id )
{
  UF_STYLER_item_value_type_t data  ;
  int irc ;
  int i ;
  char **tmp_user_names_choice ;

  data.item_id=PP_LIST_CURR;
  data.item_attr=UF_STYLER_SUBITEM_VALUES;
  irc=UF_STYLER_ask_value(dialog_id,&data);
  user_count_choice=data.count;
  tmp_user_names_choice=data.value.strings;

  //printf("- user_count_choice=%d \n",user_count_choice);
  user_names_choice = new char* [ user_count_choice ]  ;
  for(i=0;i<user_count_choice;i++)
  {
     user_names_choice[i]=(char *)malloc( strlen(tmp_user_names_choice[i])+1 ) ;
     sprintf(user_names_choice[i],"%s\0",tmp_user_names_choice[i]);
     //printf("- %d) %s \n",i,user_names_choice[i]);
  }
  UF_free_string_array( user_count_choice, (char **)tmp_user_names_choice );

  UF_STYLER_free_value (&data) ;

	return (0);
}


int _constructor_cb ( int dialog_id )
{
  UF_STYLER_item_value_type_t data  ;
  int irc ;

  if (post_count>0) {
     data.item_id=PP_LIST_CURR;
	   data.item_attr=UF_STYLER_SUBITEM_VALUES;
	   data.value.strings=(char **)post_names;
	   data.count=post_count;
	   irc=UF_STYLER_set_value(dialog_id,&data);
	   UF_STYLER_free_value (&data) ;
	}

  if (user_count>0) {
     data.item_id=PP_LIST_LIST;
	   data.item_attr=UF_STYLER_SUBITEM_VALUES;
	   data.value.strings=(char **)user_names;
	   data.count=user_count;
	   irc=UF_STYLER_set_value(dialog_id,&data);
	   UF_STYLER_free_value (&data) ;
	}

  UF_STYLER_free_value (&data) ;

	return (0);
}

int _list_list_dbl_cb ( int dialog_id)
{
    UF_STYLER_item_value_type_t data1,data2  ;
    int irc ;
    int ind1,ind2 ;

	  data1.item_id=PP_LIST_LIST;
	  data1.item_attr=UF_STYLER_VALUE;
	  data1.indicator=UF_STYLER_INTEGER_VALUE;
	  irc=UF_STYLER_ask_value(dialog_id,&data1);
	  ind1=data1.value.integer;
	  data1.indicator=UF_STYLER_STRING_VALUE;
	  irc=UF_STYLER_ask_value(dialog_id,&data1);

	  data2.item_id=PP_LIST_CURR;
	  data2.item_attr=UF_STYLER_SUBITEM_VALUES;
	  irc=UF_STYLER_ask_value(dialog_id,&data2);
	  ind2=data2.count;
	  if (ind2<=0) ind2=0; else ind2++;
	  data2.item_attr=UF_STYLER_LIST_INSERT;
	  data2.subitem_index=ind2;
	  data2.indicator=UF_STYLER_STRING_VALUE;
	  data2.value.string=data1.value.string;
	  irc=UF_STYLER_set_value(dialog_id,&data2);

	  UF_STYLER_free_value (&data1) ;
	  UF_STYLER_free_value (&data2) ;

	  return (0);

}

int _list_curr_dbl_cb ( int dialog_id)
{
    UF_STYLER_item_value_type_t data1 ;
    int irc ;
    int ind ;

	  data1.item_id=PP_LIST_CURR;
	  data1.item_attr=UF_STYLER_VALUE;
	  data1.indicator=UF_STYLER_INTEGER_VALUE;
	  irc=UF_STYLER_ask_value(dialog_id,&data1);
	  ind=data1.value.integer;
	  data1.item_attr=UF_STYLER_LIST_DELETE;
	  data1.subitem_index=ind;
	  irc=UF_STYLER_set_value(dialog_id,&data1);
	  UF_STYLER_free_value (&data1) ;

	  return (0);
}


int _blo_but_act_cb ( int dialog_id, UF_STYLER_item_value_type_p_t callback_data)
{
    UF_STYLER_item_value_type_t data1  ;
    int irc ;
    int ind ;

	  ind=callback_data->value.integer;

	  if (ind==0) //+
	  {
	  	_list_list_dbl_cb( dialog_id);
	  }
	  if (ind==1) //-
	  {
	  	_list_curr_dbl_cb( dialog_id);
	  }
	  if (ind==2) //del
	  {
	  	data1.item_id=PP_LIST_CURR;
	    data1.item_attr=UF_STYLER_LIST_DELETE;
	    data1.subitem_index=UF_STYLER_NO_SUB_INDEX;
	    irc=UF_STYLER_set_value(dialog_id,&data1);
	    UF_STYLER_free_value (&data1) ;
	  }

    return (0);

}

/*-------------------------------------------------------------------------*/
/*---------------------- UIStyler Callback Functions ----------------------*/
/*-------------------------------------------------------------------------*/

/* -------------------------------------------------------------------------
 * Callback Name: PP_constructor_cb
 * This is a callback function associated with an action taken from a
 * UIStyler object.
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the NX Open API:
 *                               UF_STYLER_ask_value(s)
 *                               UF_STYLER_set_value
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int PP_constructor_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
     /* Make sure User Function is available. */
     if ( UF_initialize() != 0)
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */
     _constructor_cb (dialog_id);

     UF_terminate ();

    /* Callback acknowledged, do not terminate dialog */
    return (UF_UI_CB_CONTINUE_DIALOG);
    /* A return value of UF_UI_CB_EXIT_DIALOG will not be accepted    */
    /* for this callback type.  You must continue dialog construction.*/

}


/* -------------------------------------------------------------------------
 * Callback Name: PP_ok_cb
 * This is a callback function associated with an action taken from a
 * UIStyler object.
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the NX Open API:
 *                               UF_STYLER_ask_value(s)
 *                               UF_STYLER_set_value
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int PP_ok_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
     /* Make sure User Function is available. */
     if ( UF_initialize() != 0)
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */
     _choice_cb ( dialog_id ) ;

     UF_terminate ();

    /* Callback acknowledged, terminate dialog             */
    /* It is STRONGLY recommended that you exit your       */
    /* callback with UF_UI_CB_EXIT_DIALOG in a ok callback.*/
    /* return ( UF_UI_CB_EXIT_DIALOG );                    */
    return (UF_UI_CB_EXIT_DIALOG);

}


/* -------------------------------------------------------------------------
 * Callback Name: PP_apply_cb
 * This is a callback function associated with an action taken from a
 * UIStyler object.
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the NX Open API:
 *                               UF_STYLER_ask_value(s)
 *                               UF_STYLER_set_value
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int PP_apply_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
     /* Make sure User Function is available. */
     if ( UF_initialize() != 0)
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */
     _choice_cb ( dialog_id ) ;

     UF_terminate ();

    /* Callback acknowledged, terminate dialog             */
    /* It is STRONGLY recommended that you exit your       */
    /* callback with UF_UI_CB_EXIT_DIALOG in a ok callback.*/
    /* return ( UF_UI_CB_EXIT_DIALOG );                    */
    return (UF_UI_CB_CONTINUE_DIALOG);

}


/* -------------------------------------------------------------------------
 * Callback Name: PP_cancel_cb
 * This is a callback function associated with an action taken from a
 * UIStyler object.
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the NX Open API:
 *                               UF_STYLER_ask_value(s)
 *                               UF_STYLER_set_value
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int PP_cancel_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
     /* Make sure User Function is available. */
     if ( UF_initialize() != 0)
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */

     UF_terminate ();

    /* Callback acknowledged, terminate dialog             */
    /* It is STRONGLY recommended that you exit your       */
    /* callback with UF_UI_CB_EXIT_DIALOG in a cancel call */
    /* back rather than UF_UI_CB_CONTINUE_DIALOG.          */
    return ( UF_UI_CB_EXIT_DIALOG );

}


/* -------------------------------------------------------------------------
 * Callback Name: PP_list_list_cb
 * This is a callback function associated with an action taken from a
 * UIStyler object.
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the NX Open API:
 *                               UF_STYLER_ask_value(s)
 *                               UF_STYLER_set_value
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int PP_list_list_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
     /* Make sure User Function is available. */
     if ( UF_initialize() != 0)
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */

     UF_terminate ();

    /* Callback acknowledged, do not terminate dialog */
    return (UF_UI_CB_CONTINUE_DIALOG);

    /* or Callback acknowledged, terminate dialog.    */
    /* return ( UF_UI_CB_EXIT_DIALOG );               */

}


/* -------------------------------------------------------------------------
 * Callback Name: PP_list_list_dbl_cb
 * This is a callback function associated with an action taken from a
 * UIStyler object.
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the NX Open API:
 *                               UF_STYLER_ask_value(s)
 *                               UF_STYLER_set_value
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int PP_list_list_dbl_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
     /* Make sure User Function is available. */
     if ( UF_initialize() != 0)
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */
	   _list_list_dbl_cb (dialog_id);

     UF_terminate ();

    /* Callback acknowledged, do not terminate dialog */
    return (UF_UI_CB_CONTINUE_DIALOG);

    /* or Callback acknowledged, terminate dialog.  */
    /* return ( UF_UI_CB_EXIT_DIALOG );             */

}


/* -------------------------------------------------------------------------
 * Callback Name: PP_blo_but_act_cb
 * This is a callback function associated with an action taken from a
 * UIStyler object.
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the NX Open API:
 *                               UF_STYLER_ask_value(s)
 *                               UF_STYLER_set_value
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int PP_blo_but_act_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{

     /* Make sure User Function is available. */
     if ( UF_initialize() != 0)
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */
	   _blo_but_act_cb (dialog_id,callback_data);

	   UF_terminate ();

    /* Callback acknowledged, do not terminate dialog */
    return (UF_UI_CB_CONTINUE_DIALOG);

    /* or Callback acknowledged, terminate dialog.    */
    /* return ( UF_UI_CB_EXIT_DIALOG );               */

}


/* -------------------------------------------------------------------------
 * Callback Name: PP_list_curr_cb
 * This is a callback function associated with an action taken from a
 * UIStyler object.
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the NX Open API:
 *                               UF_STYLER_ask_value(s)
 *                               UF_STYLER_set_value
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int PP_list_curr_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
     /* Make sure User Function is available. */
     if ( UF_initialize() != 0)
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */

     UF_terminate ();

    /* Callback acknowledged, do not terminate dialog */
    return (UF_UI_CB_CONTINUE_DIALOG);

    /* or Callback acknowledged, terminate dialog.    */
    /* return ( UF_UI_CB_EXIT_DIALOG );               */

}


/* -------------------------------------------------------------------------
 * Callback Name: PP_list_curr_dbl_cb
 * This is a callback function associated with an action taken from a
 * UIStyler object.
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the NX Open API:
 *                               UF_STYLER_ask_value(s)
 *                               UF_STYLER_set_value
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int PP_list_curr_dbl_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
     /* Make sure User Function is available. */
     if ( UF_initialize() != 0)
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */
     _list_curr_dbl_cb (dialog_id);

     UF_terminate ();

    /* Callback acknowledged, do not terminate dialog */
    return (UF_UI_CB_CONTINUE_DIALOG);

    /* or Callback acknowledged, terminate dialog.  */
    /* return ( UF_UI_CB_EXIT_DIALOG );             */

}


